<?php
namespace Teknisa\ACL\Util;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DependencyInjection\InstanceManager;
use Teknisa\ACL\Util\Instance\Service as InstanceService;
use Teknisa\ACL\Util\Instance\Repository as InstanceRepository;

class InstanceProvider {
    
    public static function getService()
    {
        return InstanceService::getInstance();
    }
    
    public static function getRepository()
    {
        return InstanceRepository::getInstance();
    }
    
    public static function getEnvironment()
    {
        return InstanceManager::getInstance()->getService('acl_environment');
    }

    /** @return \Doctrine\ORM\EntityManager */
    public static function getEntityManager()
    {
        return InstanceManager::getInstance()->getService('entityManager');
    }
    
    public static function getNewCode()
    {
        return InstanceManager::getInstance()->getService('newCodeSC');
    }

    /**
     * @return \Teknisa\Libs\Util\Environment
     * @throws \Exception
     */
    public static function getLibEnvironment()
    {
        return InstanceManager::getInstance()->getService('libEnvironment');
    }

    /**
     * @return \Teknisa\Libs\Controller\Log
     * @throws \Exception
     */
    public static function getLibLog()
    {
        return InstanceManager::getInstance()->getService('\Teknisa\Libs\Controller\Log');
    }

    public static function getLibConnectionCustom()
    {
        return InstanceManager::getInstance()->getService('connectionCustom');
    }

    /**
     * @return \Zeedhi\ZhuAcl\Controller\AccessControlRule
     * @throws \Exception
     */
    public static function getAcessControlRule()
    {
        return InstanceManager::getInstance()->getService('Teknisa\ACL\Services\AccessControlRule');
    }

    /**
     * @return \Zeedhi\ZhuAcl\Service\AccessControlRule
     * @throws \Exception
     */
    public static function getAcessControlRuleService()
    {
        return InstanceManager::getInstance()->getService('ZhuAclServiceAccessControlRule');
    }

    /**
     * @return Teknisa\ACL\Repositories\PerfAcessGremprGrupoempr
     * @throws \Exception
     */
    public static function getPerfAcessGremprGrupoempr()
    {
        return InstanceManager::getInstance()->getService('Teknisa\ACL\Repositories\PerfAcessGremprGrupoempr');
    }
}